
#include <iostream>
using namespace std;
#include <stack>

char InFix[] = "( 2 + 4 ) * 7 ";	
char PostFix[256];					
float GetPostFixResult( const char* _pPostFix );

int main(void)
{
	stack<char> s;
	int InFixLength = strlen( InFix );
	int PostFixIndex = 0;
	printf("%s\n\n", InFix );

	for( int i = 0; i < InFixLength; i++ )
	{
		char TempInFixData = InFix[i];

		switch( TempInFixData )
		{
		case ' ':
			{
				break;
			}
		case '(':
			{
				s.push( TempInFixData );
				break;
			}
		case ')':
			{
				while( s.empty() == false )
				{
					if( s.top() == '(' )
					{
						s.pop();
						break;
					}
					else
					{
						PostFix[PostFixIndex++] = s.top();
						PostFix[PostFixIndex++] = ' ';
						s.pop();
					}
				}
				break;
			}
		case '*':case '/':
			{
				if( s.empty() == true )	s.push( TempInFixData );
				else{
					if( s.top() == '*' || s.top() == '/' )
					{
						PostFix[PostFixIndex++] = s.top();
						PostFix[PostFixIndex++] = ' ';
						s.pop();
						s.push( TempInFixData );
					}
					else if( s.top() == '(' )		s.push( TempInFixData );
					
					else s.push( TempInFixData );
				}
				break;
			}
		case '+':case '-':
			{
				if( s.empty() == true )	s.push( TempInFixData );
				else{
					char TempStackData = s.top();

					if( TempStackData == '*' || TempStackData == '/' )
					{
						while( s.empty() == false )
						{
							PostFix[PostFixIndex++] = s.top();
							PostFix[PostFixIndex++] = ' ';
							s.pop();
						}
						s.push( TempInFixData );
					}
					else if( TempStackData == '(' )		s.push( TempInFixData );
					else{
						PostFix[PostFixIndex++] = s.top();
						PostFix[PostFixIndex++] = ' ';
						s.pop();
						s.push( TempInFixData );
					}
				}
				break;
			}
		default:
			{
				PostFix[PostFixIndex++] = TempInFixData;
				PostFix[PostFixIndex++] = ' ';
				break;
			}
		}
	}
	while( s.empty() == false )
	{
		PostFix[PostFixIndex++] = s.top();
		s.pop();
		PostFix[PostFixIndex++] = ' ';
	}
	printf("%s\n\n", PostFix );
	printf("%f\n", GetPostFixResult( PostFix ) );

	return 0;
}

float GetPostFixResult( const char* _pPostFix )
{
	float Result = 0.f;

	float NumTop, NumBottom = 0.f;

	stack<float> s;	

	int ArrayLength = strlen( _pPostFix );

	for( int i = 0; i < ArrayLength; i++ )
	{
		if( _pPostFix[i] == ' ' )		continue;

		else if( _pPostFix[i] == '+' || _pPostFix[i] == '-' ||
			_pPostFix[i] == '*' || _pPostFix[i] == '/' )
		{
			NumTop = s.top();		
			s.pop();
			NumBottom = s.top();
			s.pop();
			if( _pPostFix[i] == '+' )			s.push( NumBottom + NumTop );
			else if( _pPostFix[i] == '-' )		s.push( NumBottom - NumTop );
			else if( _pPostFix[i] == '*' )		s.push( NumBottom * NumTop );
			else if( _pPostFix[i] == '/' )		s.push( NumBottom / NumTop );
		}
		
		else		s.push( _pPostFix[i] - '0');
	}
	Result = s.top();
	s.pop();
	return Result;
}